/* Ver 1.0.0 for ZX Spectrum 48/128 */
/* Use ZXDev to compile this module */

#include "Timer.oh"
#include "Config.oh"

void GrApp_Close (void);
void GrApp_Cls (void);
void GrApp_ScrollDown (unsigned char lines) __z88dk_fastcall;
void GrApp_ScrollUp (unsigned char lines) __z88dk_fastcall;
void GrApp_SetPalette (void);
void GrApp__init (void);

extern unsigned char GrApp_ink, GrApp_paper;
/*================================== Header ==================================*/

static void MoveLineCtoL (void /* A=from; L=to */) __naked {
#asm
        RET
#endasm
} //MoveLineCtoL

/*--------------------------------- Cut here ---------------------------------*/
static void ClearLineL (void /*register L*/) __naked {
#asm
        RET
#endasm
} //ClearLineN

/*--------------------------------- Cut here ---------------------------------*/
void GrApp_ScrollUp (unsigned char lines) __naked __z88dk_fastcall {
/*
  unsigned media, line;
  if (lines > 0) {
    media = 192 - lines;
    for (line = 0; line < media; line ++)
      lmove (line, line + lines);
    while (line < 192)
      lclr (line ++);
  }
*/
// http://pc01.lviv.ua/forum/viewtopic.php?f=3&t=147&hilit=River&start=30#p1649
#asm
        LXI  H, 0
        DAD  SP
        SHLD STACK+1
        LXI  H, 0x4180    ; Src
        SPHL
        LXI  H, 0x4000    ; Dest
        XRA  A
        OUT  0xC2         ; Video RAM on
CYCLE:  POP  D            ; 00
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 01
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 02
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 03
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 04
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 05
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 06
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 07
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 08
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 09
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0A
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0B
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0C
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0D
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0E
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0F
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 10
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 11
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 12
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 13
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 14
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 15
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 16
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 17
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 18
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 19
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1A
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1B
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1C
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1D
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1E
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1F
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        MOV  A, H
        CPI  0x7E
        JNZ  CYCLE
        MVI  A, 2
        OUT  0xC2
STACK:  LXI  SP, 0
        RET
#endasm
} //GrApp_ScrollUp

/*--------------------------------- Cut here ---------------------------------*/
void GrApp_ScrollDown (unsigned char lines) __naked __z88dk_fastcall {
/*
  for (line = 191; line >= lines; line --)
    lmove (line, line - lines);
  while (line < 192)
    lclr (line --);
*/
#asm
    RET ; Just does not work
        LXI  H, 0
        DAD  SP
        SHLD STACK_+1
        LXI  H, 0x7A80    ; Src
        SPHL
        LXI  H, 0x7C00    ; Dest
        LXI  B, -0x80
        XRA  A
        OUT  0xC2         ; Video RAM on
CYCLE_: POP  D            ; 00
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 01
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 02
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 03
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 04
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 05
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 06
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 07
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 08
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 09
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0A
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0B
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0C
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0D
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0E
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 0F
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 10
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 11
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 12
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 13
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 14
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 15
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 16
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 17
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 18
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 19
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1A
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1B
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1C
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1D
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1E
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        POP  D            ; 1F
        MOV  M, E
        INX  H
        MOV  M, D
        INX  H
        DAD  B
        MOV  A, H
        CPI  0x3F
        JNZ  CYCLE_
        MVI  A, 2
        OUT  0xC2
STACK_: LXI  SP, 0
        RET
#endasm
} //GrApp_ScrollDown

/*--------------------------------- Cut here ---------------------------------*/
unsigned char GrApp_ink, GrApp_paper;

void GrApp_SetPalette (void) __naked {
#asm
        RET
#endasm
} //GrApp_SetPalette

/*--------------------------------- Cut here ---------------------------------*/
void GrApp_Cls (void) __naked {
#asm
        XRA  A
        OUT  0xC2         ; Video RAM on
        MVI  A, 15      ; FILL COLOR
        STA  0xBE38
        CALL 0xEBBC       ; FILL
        MVI  A, 2
        OUT  0xC2         ; Video RAM off
        RET
#endasm
} //GrApp_Cls

/*--------------------------------- Cut here ---------------------------------*/
void GrApp__init (void) __naked {
#asm
        MVI  A, 69
        OUT  0xC1         ; PALETTE
        XRA  A
        STA  0xBE38       ; BORDER
        DCR  A
        STA  0xBE3C       ; CURSOR
; Set screen table for fast tiles drawing
        LXI  D, Config_ScreenTable
        LXI  H, 0x4500
        LXI  B, 0x40      ; (next screen line)
SET_TABLE:
        MOV  A, L
        STAX D            ; low byte => Table0
        INR  D
        MOV  A, H
        STAX D            ; high byte => Table1
        DCR  D
        DAD  B            ; to next screen line
        INR  E
        JNZ  SET_TABLE
        JMP  _GrApp_Cls
#endasm
} //GrApp__init

/*--------------------------------- Cut here ---------------------------------*/
void GrApp_Close (void) __naked {
#asm
        JMP  _GrApp_Close
#endasm
} //GrApp__Close
